![Sheepstar Bot](./md/social-rounded.png)

## About The Project

This project contains the source code for the Sheepstar Bot, a Discord bot that is used to create global
channels. [Learn more here](https://sheepstar.xyz/).

## Installation

To make this process easier, we decided to make a Docker Image. You can install it by running the following command:

```bash
git clone https://github.com/SheepstarStudio/Bot.git
cd Bot
docker build -t sheepstar-bot .
```

After that, you can run the bot by running the following command:

```bash
docker run -d --name sheepstar-bot -v config.json:/data/config.json sheepstar-bot
```

You also need to create a config file. See the [config.json.example](./config.json.example) file for an example.
It contains information about the bot token and the database.

## Build from source

### Prerequisites

You need to install a few things before you can build the bot from source.

1. Installing the required dependencies from apt
    ```bash
    sudo apt-get install -y wget libssl-dev cmake g++ make libmariadb-dev
    ```
2. Installing the DPP dependency
    ```bash
    wget -O dpp.deb https://dl.dpp.dev/ && apt install ./dpp.deb -y && rm dpp.deb
    ```
3. Installing the mariadb dependency  
   Please follow the instructions on
   the [mariadb-connector-cpp](https://mariadb.com/docs/server/connect/programming-languages/cpp/install/) website to
   install the dependency.

### Building

1. Clone the repository
    ```bash
    git clone https://github.com/SheeepstarStudio/Bot.git
    cd Bot
    ```

2. Build the bot
    ```bash
    mkdir build
    cd build
    cmake ..
    make
    ```